<?php

namespace Drupal\webform_javascript_setting\Element;

use Drupal\Core\Render\Element\Hidden;

/**
 * Provides a webform element tat store a JavaScript setting in a hidden input.
 *
 * @FormElement("webform_javascript_setting")
 */
class WebformJavaScriptSetting extends Hidden {

  /**
   * {@inheritdoc}
   */
  public function getInfo() {
    $info = parent::getInfo();
    $info['#javascript_setting'] = '';
    return $info;
  }

  /**
   * {@inheritdoc}
   */
  public static function preRenderHidden($element) {
    $element = parent::preRenderHidden($element);
    $element['#attributes']['data-webform-javascript-setting'] = $element['#javascript_setting'];
    $element['#attached']['library'][] = 'webform_javascript_setting/webform_javascript_setting';
    return $element;
  }

}
